Loading...
Searching...
No Matches
AVFifo
libavutil » Data Structures

A generic FIFO API. More...

## Files

file | fifo.h
| A generic FIFO API.

## Macros

#define | AV_FIFO_FLAG_AUTO_GROW (1 << 0)
| Automatically resize the FIFO on writes, so that the data fits.

## Typedefs

typedef struct AVFifo | AVFifo
typedef int | AVFifoCB(void *opaque, void *buf, size_t *nb_elems)
| Callback for writing or reading from a FIFO, passed to (and invoked from) the av_fifo_*_cb() functions.

## Functions

AVFifo * | av_fifo_alloc2 (size_t elems, size_t elem_size, unsigned int flags)
| Allocate and initialize an AVFifo with a given element size.
size_t | av_fifo_elem_size (const AVFifo *f)
void | av_fifo_auto_grow_limit (AVFifo *f, size_t max_elems)
| Set the maximum size (in elements) to which the FIFO can be resized automatically.
size_t | av_fifo_can_read (const AVFifo *f)
size_t | av_fifo_can_write (const AVFifo *f)
int | av_fifo_grow2 (AVFifo *f, size_t inc)
| Enlarge an AVFifo.
int | av_fifo_write (AVFifo *f, const void *buf, size_t nb_elems)
| Write data into a FIFO.
int | av_fifo_write_from_cb (AVFifo *f, AVFifoCB read_cb, void *opaque, size_t *nb_elems)
| Write data from a user-provided callback into a FIFO.
int | av_fifo_read (AVFifo *f, void *buf, size_t nb_elems)
| Read data from a FIFO.
int | av_fifo_read_to_cb (AVFifo *f, AVFifoCB write_cb, void *opaque, size_t *nb_elems)
| Feed data from a FIFO into a user-provided callback.
int | av_fifo_peek (const AVFifo *f, void *buf, size_t nb_elems, size_t offset)
| Read data from a FIFO without modifying FIFO state.
int | av_fifo_peek_to_cb (const AVFifo *f, AVFifoCB write_cb, void *opaque, size_t *nb_elems, size_t offset)
| Feed data from a FIFO into a user-provided callback.
void | av_fifo_drain2 (AVFifo *f, size_t size)
| Discard the specified amount of data from an AVFifo.
void | av_fifo_reset2 (AVFifo *f)
void | av_fifo_freep2 (AVFifo **f)
| Free an AVFifo and reset pointer to NULL.

## Detailed Description

A generic FIFO API.

## Macro Definition Documentation

## AV_FIFO_FLAG_AUTO_GROW

#define AV_FIFO_FLAG_AUTO_GROW (1 << 0)

Automatically resize the FIFO on writes, so that the data fits.

This automatic resizing happens up to a limit that can be modified with av_fifo_auto_grow_limit().

Definition at line 63 of file fifo.h.

## Typedef Documentation

## AVFifo

typedef struct AVFifo AVFifo

Definition at line 38 of file fifo.h.

## AVFifoCB

typedef int AVFifoCB(void *opaque, void *buf, size_t *nb_elems)

Callback for writing or reading from a FIFO, passed to (and invoked from) the av_fifo_*_cb() functions.

It may be invoked multiple times from a single av_fifo_*_cb() call and may process less data than the maximum size indicated by nb_elems.

Parameters

  opaque | the opaque pointer provided to the av_fifo_*_cb() function
  buf | the buffer for reading or writing the data, depending on which av_fifo_*_cb function is called
  nb_elems | On entry contains the maximum number of elements that can be read from / written into buf. On success, the callback should update it to contain the number of elements actually written.

Returns
  0 on success, a negative error code on failure (will be returned from the invoking av_fifo_*_cb() function)

Definition at line 56 of file fifo.h.

## Function Documentation

## av_fifo_alloc2()

AVFifo * av_fifo_alloc2 | ( | size_t | elems,
|  | size_t | elem_size,
|  | unsigned int | flags )

Allocate and initialize an AVFifo with a given element size.

Parameters

  elems | initial number of elements that can be stored in the FIFO
  elem_size | Size in bytes of a single element. Further operations on the returned FIFO will implicitly use this element size.
  flags | a combination of AV_FIFO_FLAG_*

Returns
  newly-allocated AVFifo on success, a negative error code on failure

## av_fifo_elem_size()

size_t av_fifo_elem_size | ( | const AVFifo * | f | ) |

Returns
  Element size for FIFO operations. This element size is set at FIFO allocation and remains constant during its lifetime

## av_fifo_auto_grow_limit()

void av_fifo_auto_grow_limit | ( | AVFifo * | f,
|  | size_t | max_elems )

Set the maximum size (in elements) to which the FIFO can be resized automatically.

Has no effect unless AV_FIFO_FLAG_AUTO_GROW is used.

## av_fifo_can_read()

size_t av_fifo_can_read | ( | const AVFifo * | f | ) |

Returns
  number of elements available for reading from the given FIFO.

## av_fifo_can_write()

size_t av_fifo_can_write | ( | const AVFifo * | f | ) |

Returns
  Number of elements that can be written into the given FIFO without growing it.

In other words, this number of elements or less is guaranteed to fit into the FIFO. More data may be written when the AV_FIFO_FLAG_AUTO_GROW flag was specified at FIFO creation, but this may involve memory allocation, which can fail.

## av_fifo_grow2()

int av_fifo_grow2 | ( | AVFifo * | f,
|  | size_t | inc )

Enlarge an AVFifo.

On success, the FIFO will be large enough to hold exactly inc + av_fifo_can_read() + av_fifo_can_write() elements. In case of failure, the old FIFO is kept unchanged.

Parameters

  f | AVFifo to resize
  inc | number of elements to allocate for, in addition to the current allocated size

Returns
  a non-negative number on success, a negative error code on failure

## av_fifo_write()

int av_fifo_write | ( | AVFifo * | f,
|  | const void * | buf,
|  | size_t | nb_elems )

Write data into a FIFO.

In case nb_elems > av_fifo_can_write(f) and the AV_FIFO_FLAG_AUTO_GROW flag was not specified at FIFO creation, nothing is written and an error is returned.

Calling function is guaranteed to succeed if nb_elems <= av_fifo_can_write(f).

Parameters

  f | the FIFO buffer
  buf | Data to be written. nb_elems * av_fifo_elem_size(f) bytes will be read from buf on success.
  nb_elems | number of elements to write into FIFO

Returns
  a non-negative number on success, a negative error code on failure

## av_fifo_write_from_cb()

int av_fifo_write_from_cb | ( | AVFifo * | f,
|  | AVFifoCB | read_cb,
|  | void * | opaque,
|  | size_t * | nb_elems )

Write data from a user-provided callback into a FIFO.

Parameters

  f | the FIFO buffer
  read_cb | Callback supplying the data to the FIFO. May be called multiple times.
  opaque | opaque user data to be provided to read_cb
  nb_elems | Should point to the maximum number of elements that can be written. Will be updated to contain the number of elements actually written.

Returns
  non-negative number on success, a negative error code on failure

## av_fifo_read()

int av_fifo_read | ( | AVFifo * | f,
|  | void * | buf,
|  | size_t | nb_elems )

Read data from a FIFO.

In case nb_elems > av_fifo_can_read(f), nothing is read and an error is returned.

Parameters

  f | the FIFO buffer
  buf | Buffer to store the data. nb_elems * av_fifo_elem_size(f) bytes will be written into buf on success.
  nb_elems | number of elements to read from FIFO

Returns
  a non-negative number on success, a negative error code on failure

## av_fifo_read_to_cb()

int av_fifo_read_to_cb | ( | AVFifo * | f,
|  | AVFifoCB | write_cb,
|  | void * | opaque,
|  | size_t * | nb_elems )

Feed data from a FIFO into a user-provided callback.

Parameters

  f | the FIFO buffer
  write_cb | Callback the data will be supplied to. May be called multiple times.
  opaque | opaque user data to be provided to write_cb
  nb_elems | Should point to the maximum number of elements that can be read. Will be updated to contain the total number of elements actually sent to the callback.

Returns
  non-negative number on success, a negative error code on failure

## av_fifo_peek()

int av_fifo_peek | ( | const AVFifo * | f,
|  | void * | buf,
|  | size_t | nb_elems,
|  | size_t | offset )

Read data from a FIFO without modifying FIFO state.

Returns an error if an attempt is made to peek to nonexistent elements (i.e. if offset + nb_elems is larger than av_fifo_can_read(f)).

Parameters

  f | the FIFO buffer
  buf | Buffer to store the data. nb_elems * av_fifo_elem_size(f) bytes will be written into buf.
  nb_elems | number of elements to read from FIFO
  offset | number of initial elements to skip.

Returns
  a non-negative number on success, a negative error code on failure

## av_fifo_peek_to_cb()

int av_fifo_peek_to_cb | ( | const AVFifo * | f,
|  | AVFifoCB | write_cb,
|  | void * | opaque,
|  | size_t * | nb_elems,
|  | size_t | offset )

Feed data from a FIFO into a user-provided callback.

Parameters

  f | the FIFO buffer
  write_cb | Callback the data will be supplied to. May be called multiple times.
  opaque | opaque user data to be provided to write_cb
  nb_elems | Should point to the maximum number of elements that can be read. Will be updated to contain the total number of elements actually sent to the callback.
  offset | number of initial elements to skip; offset + *nb_elems must not be larger than av_fifo_can_read(f).

Returns
  a non-negative number on success, a negative error code on failure

## av_fifo_drain2()

void av_fifo_drain2 | ( | AVFifo * | f,
|  | size_t | size )

Discard the specified amount of data from an AVFifo.

Parameters

  size | number of elements to discard, MUST NOT be larger than av_fifo_can_read(f)

## av_fifo_reset2()

void av_fifo_reset2 | ( | AVFifo * | f | ) |

## av_fifo_freep2()

void av_fifo_freep2 | ( | AVFifo ** | f | ) |

Free an AVFifo and reset pointer to NULL.

Parameters

  f | Pointer to an AVFifo to free. *f == NULL is allowed.